# virtbit

Virtbit is an 8-bit computer emulator and framework for learning assembly programming in an 8-bit environment, similar to the Nintendo GameBoy or Nintendo Entertainment System.

The specification of the system is described in the `DOCUMENTATION` file.

## Getting Started

You need to install [Python](https://www.python.org/) to run the assembler.

The project contains an example directory in which you can find some code that shows off the different properties of the system.

You can compile the example code by calling:

    py asm\asm.py examples\gputest.asm examples\gputest.bin

Execute the binary file by calling:

    virtbit.exe examples\gputest.bin

## Convert Bitmap to Binary

The `img2bin` utility script allows you to create color and alpha mask binary files that can be included in your game and used to fill the character and mask memory.

The script looks for three colors to determine what data to generate. For the color binary, the script generates a 1 for the color white `#FFFFFF` and 0 for any non-white color. For the mask binary, the script generates a 0 (non-visible), for the color magenta `#FF00FF`, and 1 (visible) for any non-magenta color.

Thus the easiest way to go is to pick the colors black `#000000` and white `#FFFFFF` for the 0 and 1 bit, and magenta `#FF00FF` for the transparent pixels in your image. Remember that the image that is displayed on screen depends on the palette that you define, not the colors that you choose in your bitmap.

To run the script, use the following command:

    py util\img2bin.py characters.bmp

The script generates a `.colo` file, a `.mask` file, and a combined `.bin` file. You can include the binary using the `.INCBIN` instruction in your game binary.

## Disclaimer

This project is in an early stage of development. The implementation and configuration of the assembler and emulator are subject to change.
