.BYTE $0110 ;vblank int

.ZERO $0100 		;start code segment at 0x100
	jmp Init
.ZERO $0110
	jmp VBlankHandler

.INCLUDE "examples/hwd.inc"
.INCLUDE "examples/memory.inc"

Init:
	push IBM_CGA	;load characters and mask to VRAM
	push VRAM_ADDR
	push $1000
	call DMA_Copy
		
	mov a, 48		;load palette
	mov cd, PALETTE
	mov ef, PALETTE_ADDR
	call MemCopy

	call LoadText	
	call LoadColors
		
	mov a, 5			;copy sprite
	mov cd, SPRT_DATA
	mov ef, SPRT_ADDR
	call MemCopy
	
	ei
Loop:
	jmp Loop
	ret


VBlankHandler:
	mov ab, SPRT_ADDR	
	mov c, 1
	mov d, 0
	call SPRT_move
VBlankHandler_cont:
	reti


;ab sprite address
;c  x offset
;d  y offset
SPRT_move:	
	mov e, [ab] ;x
	add e, c
	cmp e, 200
	jnz SPRT_move0
	mov e, 0
SPRT_move0:
	mov [ab], e
	inc ab
	mov e, [ab] ;y	
	add e, d
	cmp e, 100
	jnz SPRT_move1
	mov e, 0
SPRT_move1:
	mov [ab], e
	ret


LoadText:
	mov ab, TEXT_ADDR	;load text
	mov cd, HELLO
LoadText0:
	mov e, [cd]
	cmp e, 0
	jnz LoadText1
	mov cd, HELLO
	mov e, [cd]
LoadText1:
	mov [ab], e		;char
	inc ab
	mov [ab], e		;color
	inc ab
	mov [ab], $E0	;attribute
	inc ab
	inc cd
	cmp ab, SPRT_ADDR
	jnz LoadText0
LoadText2:	
	ret

LoadColors:
	mov ab, TEXT_ADDR
	inc ab 				; set up for colors
	mov c, 0			; set first color
	mov [ab], $10 ;c
LoadColors0:
	add ab, 3
	inc c
	jc LoadColors1		;check for integer overflow
	mov [ab], $10 ;c
	jmp LoadColors0
LoadColors1:
	ret

	
PALETTE:
.BYTE $00,$00,$00
.BYTE $FF,$FF,$FF
.BYTE $FF,$00,$00
.BYTE $00,$FF,$00
.BYTE $00,$00,$FF
.BYTE $FF,$FF,$00
.BYTE $FF,$00,$FF
.BYTE $00,$FF,$FF
.BYTE $00,$00,$00 ;duplicate
.BYTE $80,$80,$80
.BYTE $80,$00,$00
.BYTE $00,$80,$00
.BYTE $00,$00,$80
.BYTE $80,$80,$00
.BYTE $80,$00,$80
.BYTE $00,$80,$80

HELLO:
.BYTE "Hello World!",0
	
IBM_CGA:
.INCBIN "examples/ibm_cga.bin"

SPRT_DATA:
.BYTE 12,4,1,$60,$C0

___END___:
