#!/usr/bin/env python

# convert image to 2-bit encoded binary
# 2019-03-27
# Python 3.7.0

# pip install pillow

import re
import sys

from PIL import Image

im = Image.open(sys.argv[1])
rgb_im = im.convert("RGB")

width, height = im.size

colo = bytearray()
mask = bytearray()

for y in range(0, height, 8):
    for x in range(0, width, 8):
        for i in range(8):
            databyte = 0
            maskbyte = 0xFF

            for j in range(8):
                r, g, b = rgb_im.getpixel((x+j, y+i))
                if r == 0xFF and g == 0xFF and b == 0xFF:
                    databyte = databyte | (1 << (7 - j))
                if r == 0xFF and g == 0x00 and b == 0xFF:
                    maskbyte = maskbyte & ~(1 << (7 - j))

            colo.append(databyte)
            mask.append(maskbyte)

with open(sys.argv[1] + ".colo", "wb") as out:
    out.write(colo)
with open(sys.argv[1] + ".mask", "wb") as out:
    out.write(mask)
with open(sys.argv[1] + ".bin", "wb") as out:
    out.write(colo)
    out.write(mask)